import { idb, nests } from "./common";

const nest = nests.make();

async function init() {
	const extNest = demon.summon("internal/nest");
	if (!window.__demon) {
		// this *shouldn't* be required but if we magically run into a race condition it's better to be safe
		window.__demon = {};
	}
	if (!(await idb.get("demon"))) {
		await idb.set("demon", {
			status: {},
			plugins: {}
		});
	}
	const currdemon = await idb.get("demon");
	currdemon.status = {};
	Object.keys(currdemon.plugins).forEach((key) => {
		const plug = currdemon.plugins[key];
		const exports = (0, eval)(plug.initialize);
		const ret = exports.onStart();
		nest.store[plug.meta.name].ctx = ret;
		currdemon.status[plug.meta.name] = {
			running: true
		};
	});
	extNest.store.pluginsList = currdemon.plugins;
	extNest.store.pluginsStatus = currdemon.status;
	await idb.set("demon", currdemon);
}

async function add(iife, meta) {
	const extNest = demon.summon("internal/nest");
	const currdemon = await idb.get("demon");
	const exports = (0, eval)(iife);
	if (!!exports.meta) {
		meta = exports.meta;
	}
	currdemon.plugins[meta.name] = {
		initialize: iife,
		meta: meta
	};
	extNest.store.pluginsList = currdemon.plugins;
	extNest.store.pluginsStatus = currdemon.status;
	await idb.set("demon", currdemon);
}

async function del(name) {
	const extNest = demon.summon("internal/nest");
	const currdemon = await idb.get("demon");
	if (!!currdemon.plugins[name])
		if (currdemon.status[name].running) {
			const ctx = nest.store[name].ctx;
			(0, eval)(currdemon.plugins[name].initialize).onStop(ctx);
		}
	delete currdemon.status[name];
	delete currdemon.plugins[name];
	extNest.store.pluginsList = currdemon.plugins;
	extNest.store.pluginsStatus = currdemon.status;
	await idb.set("demon", currdemon);
}

async function toggle(name) {
	const extNest = demon.summon("internal/nest");
	const currdemon = await idb.get("demon");
	if (!!currdemon.plugins[name]) {
		if (currdemon.status[name]?.running) {
			console.log(currdemon.status[name].ctx);
			const ctx = nest.store[name].ctx;
			(0, eval)(currdemon.plugins[name].initialize).onStop(ctx);
			currdemon.status[name].running = false;
		} else {
			const ret = (0, eval)(currdemon.plugins[name].initialize).onStart();
			nest.store[name].ctx = ret;
			currdemon.status[name] = {
				running: true
			};
		}
	}
	extNest.store.pluginsList = currdemon.plugins;
	extNest.store.pluginsStatus = currdemon.status;
	await idb.set("demon", currdemon);
}

export { init, add, del, toggle };

export default {
	init,
	add,
	del,
	toggle
};
