import { React, nests, nestsReact } from "../../common";
import webpack from "../../webpack";
import PlugCard from "./plugincard.jsx";

const Header = webpack.findByProps("Sizes", "Tags");
const FormTitle = webpack.findByDisplayName("FormTitle");
const FormSection = webpack.findByDisplayName("FormSection");
const FormDivider = webpack.findByDisplayName("FormDivider");

export default () => {
	const extNest = demon.summon("internal/nest");
	nestsReact.useNest(extNest);
	return (
		<>
			<Header size="demon-settings-header-size30">Plugins</Header>
			<FormDivider className="demon-settings-divider" />
			{Object.keys(extNest.ghost.pluginsList).map((k) => {
				return (
					<>
						<PlugCard name={k} nest={extNest}></PlugCard>
					</>
				);
			})}
		</>
	);
};
